VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CConnectionTable"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Accessible UML

'LICENCE
'This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'"Accessible UML" is copyright 2001-2004 Paul Blenkhorn and Gareth Evans, at UMIST,
'and is released by them under the GNU Public Licence Version 3. A copy is available
'at http://www.gnu.org/licenses/gpl.txt
'The code was written by Alasdair King.

'This class does nothing but handle whether item A can have relationship B with
'item C. All hard-coded in.

Option Explicit

Public Function Allowed(node1 As String, node2 As String, relationship As String)
    Select Case node1
        Case "Class"
            Select Case node2
                Case "Class"
                    If relationship = "Generalization" Then Allowed = True
                    If relationship = "Association" Then Allowed = True
                Case "Package"
                    If relationship = "Dependency" Then Allowed = True
                Case "Interface"
                    If relationship = "Abstraction" Then Allowed = True
                    If relationship = "Dependency" Then Allowed = True
                Case "Actor"
                    If relationship = "Association" Then Allowed = True
                    If relationship = "Abstraction" Then Allowed = True
            End Select
        Case "Object"
            If node2 = "Object" And relationship = "Link" Then Allowed = True
        Case "Package"
            If relationship = "Dependency" Then
                If node2 = "Actor" Or node2 = "Class" Or node2 = "Package" Then
                    Allowed = True
                End If
            End If
        Case "Actor"
            If node2 = "UseCase" Then
                If relationship = "Association" Then Allowed = True
                If relationship = "Communicate" Then Allowed = True
            End If
            If node2 = "Class" And relationship = "Association" Then Allowed = True
            If node2 = "Actor" And relationship = "Generalization" Then Allowed = True
            If node2 = "Package" And relationship = "Dependency" Then Allowed = True
        Case "UseCase"
            If node2 = "UseCase" Then
                If relationship = "Generalization" Then Allowed = True
                If relationship = "Include" Then Allowed = True
                If relationship = "Extend" Then Allowed = True
            End If
            If node2 = "Actor" Then
                If relationship = "Association" Then Allowed = True
                If relationship = "Communicate" Then Allowed = True
            End If
        Case "Node"
            If node2 = "Node" And relationship = "Association" Then Allowed = True
    End Select
End Function
