VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CExit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Accessible UML

'LICENCE
'This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'"Accessible UML" is copyright 2001-2004 Paul Blenkhorn and Gareth Evans, at UMIST,
'and is released by them under the GNU Public Licence Version 3. A copy is available
'at http://www.gnu.org/licenses/gpl.txt
'The code was written by Alasdair King.

Option Explicit

Private cIsConnectionEnd As Boolean ' if true, this points to a connectionEnd: if not, it points to a connection
Private cTargetConnection As CConnection
Private cTargetConnectionEnd As CConnectionEnd
Private cID As String ' the unique id

Public Property Get id() As String
    id = cID
End Property

Public Property Set connection(newConnection As CConnection)
'sets this exit to point to a connection node
    On Error Resume Next
    Set cTargetConnection = newConnection
    cID = newConnection.id
    Set cTargetConnectionEnd = Nothing
    cIsConnectionEnd = False
End Property

Public Property Get connectionType() As String
    On Error Resume Next
    If cIsConnectionEnd Then
        connectionType = cTargetConnectionEnd.endType
    Else
        connectionType = cTargetConnection.connectionType
    End If
End Property

Public Property Set connectionEnd(newConnectionEnd As CConnectionEnd)
    On Error Resume Next
'sets this exit to point to a connection node
    Set cTargetConnection = Nothing
    Set cTargetConnectionEnd = newConnectionEnd
    cID = newConnectionEnd.id
    cIsConnectionEnd = True
End Property

Public Property Get name() As String
    On Error Resume Next
    'returns the name of the exit
    If cIsConnectionEnd Then
        'this is a connectionEnd
        name = cTargetConnectionEnd.name
    Else
        'this is a connection
        name = cTargetConnection.name
    End If
End Property

Public Property Get target() As String
    On Error Resume Next
    'returns the target of the exit
    If cIsConnectionEnd Then
        'this is a connectionEnd
        target = cTargetConnectionEnd.target
    Else
        'this is a connection
        target = cTargetConnection.target
    End If
End Property

Public Property Get info() As String
    On Error Resume Next
    'returns the info of the exit
    If cIsConnectionEnd Then
        'this is a connectionEnd
        info = cTargetConnectionEnd.info
    Else
        'this is a connection
        info = cTargetConnection.info
    End If
End Property

