VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CConnection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Accessible UML

'LICENCE
'This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'"Accessible UML" is copyright 2001-2004 Paul Blenkhorn and Gareth Evans, at UMIST,
'and is released by them under the GNU Public Licence Version 3. A copy is available
'at http://www.gnu.org/licenses/gpl.txt
'The code was written by Alasdair King.

Option Explicit

Private cTarget As String ' the unique id of the target
Private cType As String ' the type of the relationship, e.g. 'Dependency'
Private cName As String
Public id As String ' the unique id

Public Property Get info() As String
'returns information about the connection, or this end of it
    On Error Resume Next
    If complete(cTarget).isConnectionEnd Then
        'this is a connectionEnd, that is, it contains lots of information (like multiplicity) so use the
        'connectionEnd info
        info = complete(cTarget).info
    Else
        'simple connection: return a little information, depending on what we've got
        info = Me.name & vbNewLine
    End If
End Property

Public Property Get name() As String
    On Error Resume Next
    name = cName
End Property

Public Property Let name(newName As String)
    On Error Resume Next
    cName = newName
End Property


Public Sub DetermineName(parent As CNode)
'this determines what the human-friendly display name of the connection should be. It is constructed from
'examination of the attributes of the connection
    On Error Resume Next
    Dim connectionIterator As CConnection
    Dim otherNode As CNode
    Dim splitName() As String
    
    If complete(cTarget).isConnectionEnd Then
        'connects to a connection end: use that friendly name, which MUST HAVE BEEN CALCULATED ALREADY. IE
        'call DetermineName on the connectionEnd objects before the connection objects
        cName = complete(cTarget).name
    Else
        'special case: if target is a Generalization node, it works like an Association node
        Set otherNode = complete(cTarget)
'        Debug.Print "otherType: " & otherNode.nodeType
'        Debug.Print "me: " & cType
        If otherNode.nodeType = "Generalization" Then
            'got a generalization!
            'Need to get the name of the other connection from the Generalization node
            cName = cType
        Else
            'nope, just normal connections
            cName = cType & " " & complete(cTarget).name
        End If
'''        'right, the target is an object. Now, the type should hold the connection type, unless it is
'''        '"Association". In this case only, there may be more to the connection - in human-friendly terms -
'''        'than the fact that it is an Association: it may be an aggregation/composition.
'''        If cType = "Association" Then
'''            'oh, this is an association: better check for aggregation
'''            If cAggregation = "none" Or Len(cAggregation) = 0 Then
'''                'okay, we're not an aggregation end: what about the other end?
'''                'Let's get the connection that points to me
'''                If complete(cTarget).isConnectionEnd Then
'''                    Set otherNode = complete(cTarget).parent
'''                Else
'''                    Set otherNode = complete(cTarget)
'''                End If
'''                For Each connectionIterator In otherNode.connections
'''                    If connectionIterator.target = parent.id Then
'''                        'found connection that points to me
'''                        If connectionIterator.aggregation = "none" Or connectionIterator.aggregation = Empty Then
'''                            'okay, we're a plain association
'''                            cName = cType & " relationship "
'''                            'provide direction
'''                            If cDirection = Empty Or cDirection = "both" Then
'''                                cName = cName & "with"
'''                            Else
'''                                cName = cName & cDirection
'''                            End If
'''                            cName = cName & " " & complete(cTarget).name
'''                            Exit For
'''                        Else
'''                            'oops, the other end is an aggregation/composition
'''                            If connectionIterator.aggregation = "composite" Then
'''                                cName = "Composed by " & complete(cTarget).name
'''                            Else
'''                                'aggregation
'''                                cName = "Aggregate of " & complete(cTarget).name
'''                            End If
'''                            'Debug.Print "agg:" & connectionIterator.aggregation
'''                        End If
'''                    End If
'''                Next connectionIterator
'''                'ASSERTION: we MUST have assigned a connection name. Relies on the connection existing at the
'''                'target node that points back to this one.
'''            Else
'''                'we're an aggregation/composition of the node at the other end of the connection
'''                If cAggregation = "composite" Then
'''                    cName = "Composes " & complete(cTarget).name
'''                Else
'''                    'aggregation
'''                    cName = "Aggregates to create " & complete(cTarget).name
'''                End If
'''            End If
'''        Else
'''            'we're not an association: generate a standard name
'''            'are we a generalization?
'''            If InStr(1, cType, "inherit", vbTextCompare) > 0 Or InStr(1, cType, "Superclass", vbTextCompare) > 0 Or InStr(1, cType, "Extend", vbTextCompare) > 0 Then
'''                'yes we are! Uses the word "Inherit" or the word "Superclass" or "Extend"
'''                cName = cType & " " & complete(cTarget).name
'''            ElseIf InStr(1, cType, "use", vbTextCompare) > 0 Then
'''                'nope, but we're a use relationship from a use case diagram
'''                cName = cType & " " & complete(cTarget).name
'''            ElseIf InStr(1, cType, "transition", vbTextCompare) > 0 Then
'''                'we're a transition
'''                cName = cType & " " & complete(cTarget).name
'''            Else
'''                'nope, generate relationship name
'''                cName = cType & " relationship "
'''                If cDirection = Empty Or cDirection = "both" Then
'''                    cName = cName & "with"
'''                Else
'''                    cName = cName & cDirection
'''                End If
'''                cName = cName & " " & complete(cTarget).name
'''            End If
'''        End If
    End If
    'Debug.Print "Connection named: " & cName
End Sub

Public Property Get target() As String
    On Error Resume Next
    target = cTarget
End Property

Public Property Let target(newTarget As String)
    On Error Resume Next
    cTarget = newTarget
End Property

Public Property Get connectionType() As String
    On Error Resume Next
    connectionType = cType
End Property

Public Property Let connectionType(newConnectionType As String)
    On Error Resume Next
    cType = newConnectionType
End Property

