<?xml version="1.0" encoding="UTF-8"?>
<!-- This stylesheet converts XMI1.2 into a visual display of the contents. Lovely and colourful. -->
<xsl:stylesheet       xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
      xmlns:UML="org.omg.xmi.namespace.UML"
      version="1.0">
	<xsl:output method="html"/>
	<xsl:key name="nodeIndex" match="*[@xmi.id]" use="@xmi.id" />
	<xsl:template match="//XMI.header"></xsl:template>
	<xsl:template match="/">
   		<html>
   			<head><title>XMI as HTML</title></head>
   			<body>
   				<xsl:apply-templates/>
   			</body>
   		</html>
   	</xsl:template>
   	
   	<xsl:template match="//XMI.content/UML:Diagram">
   		<h1><xsl:attribute name="class">diagram</xsl:attribute><xsl:value-of select="@name"/></h1>
   		<xsl:apply-templates select="UML:GraphElement.contained"/>
   	</xsl:template>
   	<xsl:template match="UML:GraphElement.contained/UML:GraphNode[UML:GraphElement.semanticModel/UML:Uml1SemanticModelBridge]">
   		<div>
   			<xsl:attribute name="style">
   				<xsl:text>position:absolute;</xsl:text>
   				<xsl:text>left:</xsl:text><xsl:value-of select="UML:GraphElement.position/XMI.field[1]"/><xsl:text>;</xsl:text>
   				<xsl:text>top:</xsl:text><xsl:value-of select="UML:GraphElement.position/XMI.field[2]"/><xsl:text>;</xsl:text>
   				<xsl:text>width:</xsl:text><xsl:value-of select="UML:GraphNode.size/XMI.field[1]"/><xsl:text>;</xsl:text>
   				<xsl:text>height:</xsl:text><xsl:value-of select="UML:GraphNode.size/XMI.field[2]"/><xsl:text>;</xsl:text>
   				<xsl:for-each select="UML:GraphElement.semanticModel/UML:Uml1SemanticModelBridge/UML:Uml1SemanticModelBridge.element/*">
   					<xsl:choose>
	   					<xsl:when test="local-name() = 'Class'">
	   						<xsl:text>background-color:yellow;border:solid;</xsl:text>
	   					</xsl:when>
	   					<!-- <xsl:when test="local-name() = 'UseCase'">
	   						<xsl:text>background-color:green;</xsl:text>
	   					</xsl:when> 
	   					<xsl:when test="local-name() = 'Actor'">
	   						<xsl:text>background-color:red;</xsl:text>
	   					</xsl:when>	   					
	   					<xsl:when test="local-name() = 'Object'">
	   						<xsl:text>background-color:blue;</xsl:text>
	   					</xsl:when>	   
	   					<xsl:when test="local-name() = 'Stimulus'">
	   						<xsl:text>background-color:orange;</xsl:text>
	   					</xsl:when>	   
	   					<xsl:when test="local-name() = 'SendAction'">
	   						<xsl:text>background-color:purple;</xsl:text>
	   					</xsl:when>	 -->   
	   					<xsl:otherwise>
	   						<xsl:text>display:none;</xsl:text>
	   					</xsl:otherwise>
   					</xsl:choose>
   					<xsl:for-each select="">
		   				<xsl:value-of select="@name"/>
		   			</xsl:for-each>
   				</xsl:for-each>

   			</xsl:attribute>
   		
   			<xsl:apply-templates/>
   		</div>
   	</xsl:template>
   	<xsl:template match="XMI.field"/>
   	<xsl:template match="UML:Stereotype.baseClass"/>
   	<xsl:template match="UML:Model" priority="-1"/>
</xsl:stylesheet>