VERSION 5.00
Begin VB.Form frmShow 
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Show items by type"
   ClientHeight    =   3090
   ClientLeft      =   45
   ClientTop       =   315
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3090
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Tag             =   "frmShow"
   Begin VB.CommandButton cmdShowOK 
      Cancel          =   -1  'True
      Caption         =   "OK"
      Height          =   495
      Left            =   1680
      TabIndex        =   2
      Top             =   2520
      Width           =   1215
   End
   Begin VB.ListBox lstShow 
      Height          =   1635
      ItemData        =   "frmShow.frx":0000
      Left            =   120
      List            =   "frmShow.frx":0002
      Sorted          =   -1  'True
      Style           =   1  'Checkbox
      TabIndex        =   1
      Top             =   480
      Width           =   4335
   End
   Begin VB.Label lblTypes 
      Caption         =   "&Types of item"
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Tag             =   "frmShow.lblTypes"
      Top             =   120
      Width           =   3495
   End
End
Attribute VB_Name = "frmShow"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Accessible UML

'LICENCE
'This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'"Accessible UML" is copyright 2001-2004 Paul Blenkhorn and Gareth Evans, at UMIST,
'and is released by them under the GNU Public Licence Version 3. A copy is available
'at http://www.gnu.org/licenses/gpl.txt
'The code was written by Alasdair King.

Option Explicit

Public nodeTypesToShow As Dictionary
Public nodeTypesToHide As Dictionary

Public Sub PopulateTypes()
    On Error Resume Next
    'populate the list box with the nodes to display from the diagram
    Dim types As New Dictionary
    Dim nodeIterator As CNode
    Dim iterator As Variant
    Dim i As Integer
    
    'go through all the nodes, finding all the unique node types
    For Each nodeIterator In diagramNodes
        If Not types.Exists(nodeIterator.nodeType) Then
            'found a new type we haven't added to the dictionary yet
            Call types.add(nodeIterator.nodeType, nodeIterator.nodeType)
        End If
    Next nodeIterator
    'dictionary types now contains all the types
    Call lstShow.Clear
    For Each iterator In types
        Call lstShow.AddItem(iterator)
    Next iterator
    'tick boxes to indicate items currently viewed
    If Not (nodeTypesToShow Is Nothing) Then
        For i = 0 To lstShow.ListCount - 1
            If nodeTypesToShow.Exists(lstShow.List(i)) Then
                lstShow.Selected(i) = True
            Else
                lstShow.Selected(i) = False
            End If
        Next i
    End If
    'set up nodestoshow: the default is to show every node in the diagram
    Set nodeTypesToShow = New Dictionary
    Set nodeTypesToHide = New Dictionary
    For Each iterator In types
        Call nodeTypesToShow.add(iterator, iterator)
    Next iterator
End Sub

Private Sub cmdShowOK_Click()
    On Error Resume Next
    'record which items to hide/show
    Dim i As Integer
    
    Set nodeTypesToShow = New Dictionary
    Set nodeTypesToHide = New Dictionary
    'go through show list, recording which ones are checked
    For i = 0 To lstShow.ListCount - 1
        If lstShow.Selected(i) Then
            'list item is checked: show this type - add it to nodeTypesToShow
            Call nodeTypesToShow.add(lstShow.List(i), lstShow.List(i))
        Else
            'list item is clear: hide this type - add it to nodeTypesToHide
            Call nodeTypesToHide.add(lstShow.List(i), lstShow.List(i))
        End If
    Next i
    Call Me.Hide
End Sub

Private Sub Form_Activate()
    Call PopulateTypes
End Sub

