Attribute VB_Name = "modBack"
'Accessible UML

'LICENCE
'This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'"Accessible UML" is copyright 2001-2004 Paul Blenkhorn and Gareth Evans, at UMIST,
'and is released by them under the GNU Public Licence Version 3. A copy is available
'at http://www.gnu.org/licenses/gpl.txt
'The code was written by Alasdair King.

Option Explicit

Public backNodes As Collection ' collection of nodes previously visited
Public forwardNodes As Collection ' collection of nodes forward

Public Sub RecordMove(lastNode As CNode)
    On Error Resume Next
    If Not (lastNode Is Nothing) Then
        If backNodes.Count > 0 Then
            If lastNode.id = backNodes(backNodes.Count) Then
                Exit Sub
            End If
        End If
        Call backNodes.add(lastNode.id)
        'if this is a move forward, don't delete the forwards collection: otherwise, do so
        If (forwardNodes Is Nothing) Then
            Set forwardNodes = New Collection
        Else
            If forwardNodes.Count > 0 Then
                If forwardNodes(forwardNodes.Count) = lastNode.id Then
                    'this is a move forward
                    Call forwardNodes.Remove(forwardNodes.Count)
                Else
                    Set forwardNodes = New Collection
                End If
            End If
        End If
    End If
End Sub

Public Function GoBack(currentNode As CNode) As String
    On Error Resume Next
    If backNodes.Count > 1 Then
        GoBack = backNodes(backNodes.Count - 1)
        Call backNodes.Remove(backNodes.Count)
        Call forwardNodes.add(currentNode.id)
    End If
End Function


Public Function GoForward(currentNode As CNode) As String
    On Error Resume Next
    If forwardNodes.Count > 0 Then
        GoForward = forwardNodes(forwardNodes.Count)
        Call backNodes.add(currentNode.id)
    End If
End Function
