Attribute VB_Name = "modFind"
'Accessible UML

'LICENCE
'This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'"Accessible UML" is copyright 2001-2004 Paul Blenkhorn and Gareth Evans, at UMIST,
'and is released by them under the GNU Public Licence Version 3. A copy is available
'at http://www.gnu.org/licenses/gpl.txt
'The code was written by Alasdair King.

Option Explicit

Public searchPhrase As String

Private Function Compare(testNode As CNode, search As String) As Boolean
    On Error Resume Next
    Dim iterator As CConnectionEnd
    Compare = False
    If frmFind.chkNodes.Value = vbChecked Then
        If InStr(1, testNode.name, search, vbTextCompare) > 0 Then
            Compare = True
        End If
    End If
    If frmFind.chkAnnotation.Value = vbChecked Then
        If InStr(1, testNode.annotation, search, vbTextCompare) > 0 Then
            Compare = True
        End If
    End If
End Function

Public Sub Find(search As String)
    On Error Resume Next
    Dim nodeIterator As CNode
    Dim look As Boolean
    Dim foundID  As String
       look = False
        foundID = Empty
        For Each nodeIterator In diagramNodes
            If look Then
                If Compare(nodeIterator, search) Then
                    'found!
                    foundID = nodeIterator.id
                    Exit For
                End If
            End If
            If nodeIterator.id = currentNode.id Then
                look = True
            End If
        Next nodeIterator
        If Len(foundID) = 0 Then
            'start looking from first node until we get to ours
            For Each nodeIterator In diagramNodes
                'check we haven't returned to our current node
                If nodeIterator.id = currentNode.id Then
                    Exit For
                End If
                'if not, check if this is the node wanted
                If Compare(nodeIterator, search) Then
                    'found!
                    foundID = nodeIterator.id
                    Exit For
                End If
            Next nodeIterator
        End If
        'check to see if we've found anything
        If Len(foundID) > 0 Then
            Call frmMain.GoToNode(foundID)
        Else
            Call MsgBox(frmMain.language.GetText("Item not found"), vbExclamation, frmMain.language.GetText("Not found"))
        End If
End Sub
